//+------------------------------------------------------------------+
//| 3 ducks indicator      version 1                                 |
//|                                                                  |
//|      The indicator follows the rules of original 3 ducks system. |
//|      Indicator status is shown in the right upper corner of the  |
//|      chart. When all 3 timeframes have the same color, sell or   |
//|      buy.                                                        |
//|      Indicator also contains an audible alarm.                   |
//|      Indicator position in the window can be adjusted.           |
//|                                                                  |
//|                   by Rocroy, 3-22-2008                           |
//|                                                                  |
//+------------------------------------------------------------------+

#property indicator_chart_window

extern color ColorUpGood = Lime;
extern color ColorDownGood = Red;
extern int   Left_position = 0;
extern bool  SoundON=false;
extern int   Number_of_Alarms = 5;

static int   alertTag, alertcount;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   IndicatorShortName("3 Ducks");
   alertcount = Number_of_Alarms;
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   ObjectsDeleteAll(0,OBJ_LABEL); 
   ObjectDelete("heading"); ObjectDelete("M15"); ObjectDelete("H1"); ObjectDelete("H4"); 
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {    
    
    //m15 data
    double m15ma = iMA(NULL,PERIOD_M15,50,0,MODE_SMA,PRICE_CLOSE,0);

    //h1 data
    double h1ma = iMA(NULL,PERIOD_H1,50,0,MODE_SMA,PRICE_CLOSE,0);

    //h4 data
    double h4ma = iMA(NULL,PERIOD_H4,50,0,MODE_SMA,PRICE_CLOSE,0);
    
    //define color
    color color_m15, color_h1, color_h4;
    
    //define string
    string arrow_m15, arrow_h1, arrow_h4;
        

    //m15 up trend
    if (m15ma < Bid ) { color_m15 = ColorUpGood; }
    
    //m15 down trend
    if (m15ma > Bid ) { color_m15 = ColorDownGood; }

    //h1 up trend
    if (h1ma < Bid ) { color_h1 = ColorUpGood; }
    
    //h1 down trend
    if (h1ma > Bid ) { color_h1 = ColorDownGood; }

    //h4 up trend
    if (h4ma < Bid ) { color_h4 = ColorUpGood; }
    
    //h4 down trend
    if (h4ma > Bid ) { color_h4 = ColorDownGood; }
    
    
    //Heading           
    ObjectCreate("heading", OBJ_LABEL, 0, 0, 0);
        ObjectSetText("heading","3 Ducks",18, "Segoe UI", color_m15);
        ObjectSet("heading", OBJPROP_XDISTANCE, 985+Left_position);
        ObjectSet("heading", OBJPROP_YDISTANCE, 50);
        
    //Signal Labels           
    ObjectCreate("M15", OBJ_LABEL, 0, 0, 0);//M5 SIGNAL
        ObjectSetText("M15","M15",14, "Segoe UI", color_m15);
        ObjectSet("M15", OBJPROP_XDISTANCE, 940+Left_position);
        ObjectSet("M15", OBJPROP_YDISTANCE, 100);
        
    ObjectCreate("H1", OBJ_LABEL, 0, 0, 0);//H1 SIGNAL
        ObjectSetText("H1","H1",14, "Segoe UI", color_h1);
        ObjectSet("H1", OBJPROP_CORNER, 0);
        ObjectSet("H1", OBJPROP_XDISTANCE, 1015+Left_position);
        ObjectSet("H1", OBJPROP_YDISTANCE, 100);
        
    ObjectCreate("H4", OBJ_LABEL, 0, 0, 0);//H4 SIGNAL
        ObjectSetText("H4","H4",14, "Segoe UI", color_h4);
        ObjectSet("H4", OBJPROP_CORNER, 0);
        ObjectSet("H4", OBJPROP_XDISTANCE, 1085+Left_position);
        ObjectSet("H4", OBJPROP_YDISTANCE, 100);

   
      if (m15ma < Bid) { arrow_m15 = "5"; }
      if (m15ma > Bid) { arrow_m15 = "6"; }

      if (h1ma < Bid) { arrow_h1 = "5"; }
      if (h1ma > Bid) { arrow_h1 = "6"; }

      if (h4ma < Bid) { arrow_h4 = "5"; }
      if (h4ma > Bid) { arrow_h4 = "6"; }

      
      //arrow m15
      ObjectCreate("ObjLabel9a", OBJ_LABEL, 0, 0, 0);
        ObjectSetText("ObjLabel9a",arrow_m15,18, "Webdings", color_m15);
        ObjectSet("ObjLabel9a", OBJPROP_XDISTANCE, 948+Left_position);
        ObjectSet("ObjLabel9a", OBJPROP_YDISTANCE, 130);
        
      //arrow h1
      ObjectCreate("ObjLabel10a", OBJ_LABEL, 0, 0, 0);
        ObjectSetText("ObjLabel10a",arrow_h1,18, "Webdings", color_h1);
        ObjectSet("ObjLabel10a", OBJPROP_XDISTANCE, 1015+Left_position);
        ObjectSet("ObjLabel10a", OBJPROP_YDISTANCE, 130);
    
      //arrow h4
      ObjectCreate("ObjLabel11a", OBJ_LABEL, 0, 0, 0);
        ObjectSetText("ObjLabel11a",arrow_h4,18, "Webdings", color_h4);
        ObjectSet("ObjLabel11a", OBJPROP_XDISTANCE, 1085+Left_position);
        ObjectSet("ObjLabel11a", OBJPROP_YDISTANCE, 130);        
        
// alarms
      
      if ( color_m15 != color_h1 || color_h1 != color_h4 ) alertcount = Number_of_Alarms;
      
      if (SoundON==true && color_m15 == color_h1 && color_h1 == color_h4 &&
         alertcount>0 && alertTag!=TimeMinute(TimeCurrent()) )
      {
         Alert(" 3 Ducks in a row! ",Symbol());
         alertTag = TimeMinute(TimeCurrent());
         if (alertcount > 0) alertcount--;
      }
      
        
//----
    return(0); 
//----
} 

//+------------------------------------------------------------------+